// @generated by protobuf-ts 2.9.1
// @generated from protobuf file "monitor.proto" (package "listener", syntax proto3)
// tslint:disable
import { Empty } from "./google/protobuf/empty";
import { ServiceType } from "@protobuf-ts/runtime-rpc";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import { WireType } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import { UnknownFieldHandler } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { reflectionMergePartial } from "@protobuf-ts/runtime";
import { MESSAGE_TYPE } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
/**
 * @generated from protobuf message listener.ServicesResponse
 */
export interface ServicesResponse {
    /**
     * @generated from protobuf field: repeated listener.ServicesItems Methods = 1 [json_name = "Methods"];
     */
    methods: ServicesItems[];
}
/**
 * @generated from protobuf message listener.ParameterFunction
 */
export interface ParameterFunction {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string;
    /**
     * @generated from protobuf field: string Send = 2 [json_name = "Send"];
     */
    send: string;
    /**
     * @generated from protobuf field: string Recv = 3 [json_name = "Recv"];
     */
    recv: string;
}
/**
 * @generated from protobuf message listener.Vault
 */
export interface Vault {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string; // @gotags: yaml:"name"
    /**
     * @generated from protobuf field: string Address = 2 [json_name = "Address"];
     */
    address: string; // @gotags: yaml:"address"
    /**
     * @generated from protobuf field: string Token = 3 [json_name = "Token"];
     */
    token: string; // @gotags: yaml:"token"
    /**
     * @generated from protobuf field: repeated string Keys = 4 [json_name = "Keys"];
     */
    keys: string[]; // @gotags: yaml:"keys"
}
/**
 * @generated from protobuf message listener.RouterListener
 */
export interface RouterListener {
    /**
     * @generated from protobuf field: string Name = 1 [json_name = "Name"];
     */
    name: string; // @gotags: yaml:"name" validate:"required" gorm:"column:name;primaryKey" mapstructure:"name"
    /**
     * @generated from protobuf field: string Pem = 2 [json_name = "Pem"];
     */
    pem: string; // @gotags: yaml:"pem"  gorm:"column:pem" mapstructure:"pem"
    /**
     * @generated from protobuf field: int32 Port = 3 [json_name = "Port"];
     */
    port: number; // @gotags: yaml:"port" validate:"required,min=1,max=65535" gorm:"column:port" mapstructure:"port"
    /**
     * @generated from protobuf field: string Listen = 4 [json_name = "Listen"];
     */
    listen: string; // @gotags: yaml:"listen" validate:"required,hostname_rfc1123" gorm:"column:listen" mapstructure:"listen"
    /**
     * @generated from protobuf field: bool Secure = 5 [json_name = "Secure"];
     */
    secure: boolean; // @gotags: yaml:"secure" gorm:"column:secure" mapstructure:"secure"
    /**
     * @generated from protobuf field: bool AutoReloadPemDir = 6 [json_name = "AutoReloadPemDir"];
     */
    autoReloadPemDir: boolean; // @gotags: yaml:"autoReloadPemDir" gorm:"column:autoReloadPemDir" mapstructure:"autoReloadPemDir"
    /**
     * @generated from protobuf field: listener.Vault Vault = 7 [json_name = "Vault"];
     */
    vault?: Vault; // @gotags: yaml:"vault" gorm:"-" mapstructure:"-"
}
/**
 * @generated from protobuf message listener.ServicesItems
 */
export interface ServicesItems {
    /**
     * @generated from protobuf field: string Service = 1 [json_name = "Service"];
     */
    service: string;
    /**
     * @generated from protobuf field: string Method = 2 [json_name = "Method"];
     */
    method: string;
    /**
     * @generated from protobuf field: string FullMethod = 3 [json_name = "FullMethod"];
     */
    fullMethod: string;
    /**
     * @generated from protobuf field: repeated string HttpTranslator = 4 [json_name = "HttpTranslator"];
     */
    httpTranslator: string[];
    /**
     * @generated from protobuf field: repeated listener.ParameterFunction Input = 5 [json_name = "Input"];
     */
    input: ParameterFunction[];
    /**
     * @generated from protobuf field: repeated listener.ParameterFunction Output = 6 [json_name = "Output"];
     */
    output: ParameterFunction[];
    /**
     * @generated from protobuf field: bool ServerStream = 7 [json_name = "ServerStream"];
     */
    serverStream: boolean;
    /**
     * @generated from protobuf field: bool ClientStream = 8 [json_name = "ClientStream"];
     */
    clientStream: boolean;
    /**
     * @generated from protobuf field: string ProtoReference = 9 [json_name = "ProtoReference"];
     */
    protoReference: string;
}
/**
 * Monitor sections
 *
 * @generated from protobuf message listener.MonitorRequest
 */
export interface MonitorRequest {
    /**
     * @generated from protobuf field: bool DisableHostInfo = 1 [json_name = "DisableHostInfo"];
     */
    disableHostInfo: boolean;
}
/**
 * @generated from protobuf message listener.RateLimit
 */
export interface RateLimit {
    /**
     * @generated from protobuf field: string ID = 1 [json_name = "ID"];
     */
    iD: string;
    /**
     * @generated from protobuf field: string Alias = 2 [json_name = "Alias"];
     */
    alias: string;
    /**
     * @generated from protobuf field: string Type = 3 [json_name = "Type"];
     */
    type: string;
    /**
     * @generated from protobuf field: double Limit = 4 [json_name = "Limit"];
     */
    limit: number;
    /**
     * @generated from protobuf field: int64 Current = 5 [json_name = "Current"];
     */
    current: bigint;
}
/**
 * @generated from protobuf message listener.MonitorResponse
 */
export interface MonitorResponse {
    /**
     * @generated from protobuf field: string ServicesName = 1 [json_name = "ServicesName"];
     */
    servicesName: string; // @gotags: json:"servicesName,omitempty"
    /**
     * @generated from protobuf field: int64 Time = 2 [json_name = "Time"];
     */
    time: bigint; // @gotags: json:"time,omitempty"
    /**
     * @generated from protobuf field: listener.Host Host = 3 [json_name = "Host"];
     */
    host?: Host; // @gotags: json:"host,omitempty"
    /**
     * @generated from protobuf field: listener.Services Services = 4 [json_name = "Services"];
     */
    services?: Services; // @gotags: json:"services,omitempty"
    /**
     * @generated from protobuf field: repeated listener.RateLimit RateLimit = 5 [json_name = "RateLimit"];
     */
    rateLimit: RateLimit[]; // @gotags: json:"rateLimit,omitempty"
}
/**
 * @generated from protobuf message listener.Cpu
 */
export interface Cpu {
    /**
     * @generated from protobuf field: float UsagePercent = 1 [json_name = "UsagePercent"];
     */
    usagePercent: number; // @gotags: json:"usagePercent,omitempty"
}
/**
 * @generated from protobuf message listener.Memory
 */
export interface Memory {
    /**
     * @generated from protobuf field: uint64 Total = 1 [json_name = "Total"];
     */
    total: bigint; // @gotags: json:"total,omitempty"
    /**
     * @generated from protobuf field: string TotalString = 2 [json_name = "TotalString"];
     */
    totalString: string; // @gotags: json:"totalString,omitempty"
    /**
     * @generated from protobuf field: uint64 Usage = 3 [json_name = "Usage"];
     */
    usage: bigint; // @gotags: json:"usage,omitempty"
    /**
     * @generated from protobuf field: string UsageString = 4 [json_name = "UsageString"];
     */
    usageString: string; // @gotags: json:"usageString,omitempty"
    /**
     * @generated from protobuf field: float UsagePercent = 5 [json_name = "UsagePercent"];
     */
    usagePercent: number; // @gotags: json:"usagePercent,omitempty"
}
/**
 * @generated from protobuf message listener.Host
 */
export interface Host {
    /**
     * @generated from protobuf field: listener.Cpu Cpu = 1 [json_name = "Cpu"];
     */
    cpu?: Cpu; // @gotags: json:"cpu,omitempty"
    /**
     * @generated from protobuf field: listener.Memory Memory = 2 [json_name = "Memory"];
     */
    memory?: Memory; // @gotags: json:"memory,omitempty"
    /**
     * @generated from protobuf field: listener.HostInfo HostInfo = 3 [json_name = "HostInfo"];
     */
    hostInfo?: HostInfo; // @gotags: json:"hostInfo,omitempty"
}
/**
 * @generated from protobuf message listener.HostInfo
 */
export interface HostInfo {
    /**
     * @generated from protobuf field: string Hostname = 1 [json_name = "Hostname"];
     */
    hostname: string; // @gotags: json:"hostname,omitempty"
    /**
     * @generated from protobuf field: uint64 Uptime = 2 [json_name = "Uptime"];
     */
    uptime: bigint; // @gotags: json:"uptime,omitempty"
    /**
     * @generated from protobuf field: uint64 BootTime = 3 [json_name = "BootTime"];
     */
    bootTime: bigint; // @gotags: json:"bootTime,omitempty"
    /**
     * @generated from protobuf field: uint64 Procs = 4 [json_name = "Procs"];
     */
    procs: bigint; // @gotags: json:"procs,omitempty"
    /**
     * @generated from protobuf field: string OS = 5 [json_name = "OS"];
     */
    oS: string; // @gotags: json:"os,omitempty"
    /**
     * @generated from protobuf field: string Platform = 6 [json_name = "Platform"];
     */
    platform: string; // @gotags: json:"platform,omitempty"
    /**
     * @generated from protobuf field: string PlatformFamily = 7 [json_name = "PlatformFamily"];
     */
    platformFamily: string; // @gotags: json:"platformFamily,omitempty"
    /**
     * @generated from protobuf field: string PlatformVersion = 8 [json_name = "PlatformVersion"];
     */
    platformVersion: string; // @gotags: json:"platformVersion,omitempty"
    /**
     * @generated from protobuf field: string KernelVersion = 9 [json_name = "KernelVersion"];
     */
    kernelVersion: string; // @gotags: json:"kernelVersion,omitempty"
    /**
     * @generated from protobuf field: string KernelArch = 10 [json_name = "KernelArch"];
     */
    kernelArch: string; // @gotags: json:"kernelArch,omitempty"
    /**
     * @generated from protobuf field: string VirtualizationSystem = 11 [json_name = "VirtualizationSystem"];
     */
    virtualizationSystem: string; // @gotags: json:"virtualizationSystem,omitempty"
    /**
     * @generated from protobuf field: string VirtualizationRole = 12 [json_name = "VirtualizationRole"];
     */
    virtualizationRole: string; // @gotags: json:"virtualizationRole,omitempty"
    /**
     * @generated from protobuf field: string HostID = 13 [json_name = "HostID"];
     */
    hostID: string; // @gotags: json:"hostID,omitempty"
}
/**
 * @generated from protobuf message listener.ServicesInfo
 */
export interface ServicesInfo {
    /**
     * @generated from protobuf field: string Version = 1 [json_name = "Version"];
     */
    version: string; // @gotags: json:"version,omitempty"
    /**
     * @generated from protobuf field: string GitCommit = 2 [json_name = "GitCommit"];
     */
    gitCommit: string; // @gotags: json:"gitCommit,omitempty"
    /**
     * @generated from protobuf field: string GoVersion = 3 [json_name = "GoVersion"];
     */
    goVersion: string; // @gotags: json:"goVersion,omitempty"
    /**
     * @generated from protobuf field: string Compiler = 4 [json_name = "Compiler"];
     */
    compiler: string; // @gotags: json:"compiler,omitempty"
    /**
     * @generated from protobuf field: string BuildTime = 5 [json_name = "BuildTime"];
     */
    buildTime: string; // @gotags: json:"buildTime,omitempty"
}
/**
 * @generated from protobuf message listener.Services
 */
export interface Services {
    /**
     * @generated from protobuf field: string Runtime = 1 [json_name = "Runtime"];
     */
    runtime: string; // @gotags: json:"runtime,omitempty"
    /**
     * @generated from protobuf field: int32 NumGoroutine = 2 [json_name = "NumGoroutine"];
     */
    numGoroutine: number; // @gotags: json:"numGoroutine,omitempty"
    /**
     * @generated from protobuf field: int32 Pid = 3 [json_name = "Pid"];
     */
    pid: number; // @gotags: json:"pid,omitempty"
    /**
     * @generated from protobuf field: listener.Cpu Cpu = 4 [json_name = "Cpu"];
     */
    cpu?: Cpu; // @gotags: json:"cpu,omitempty"
    /**
     * @generated from protobuf field: listener.Memory Memory = 5 [json_name = "Memory"];
     */
    memory?: Memory; // @gotags: json:"memory,omitempty"
    /**
     * @generated from protobuf field: listener.ServicesInfo ServicesInfo = 6 [json_name = "ServicesInfo"];
     */
    servicesInfo?: ServicesInfo; // @gotags: json:"servicesInfo,omitempty"
}
// @generated message type with reflection information, may provide speed optimized methods
class ServicesResponse$Type extends MessageType<ServicesResponse> {
    constructor() {
        super("listener.ServicesResponse", [
            { no: 1, name: "Methods", kind: "message", jsonName: "Methods", repeat: 1 /*RepeatType.PACKED*/, T: () => ServicesItems }
        ]);
    }
    create(value?: PartialMessage<ServicesResponse>): ServicesResponse {
        const message = { methods: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<ServicesResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ServicesResponse): ServicesResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* repeated listener.ServicesItems Methods = 1 [json_name = "Methods"];*/ 1:
                    message.methods.push(ServicesItems.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: ServicesResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* repeated listener.ServicesItems Methods = 1 [json_name = "Methods"]; */
        for (let i = 0; i < message.methods.length; i++)
            ServicesItems.internalBinaryWrite(message.methods[i], writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.ServicesResponse
 */
export const ServicesResponse = new ServicesResponse$Type();
// @generated message type with reflection information, may provide speed optimized methods
class ParameterFunction$Type extends MessageType<ParameterFunction> {
    constructor() {
        super("listener.ParameterFunction", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Send", kind: "scalar", jsonName: "Send", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "Recv", kind: "scalar", jsonName: "Recv", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<ParameterFunction>): ParameterFunction {
        const message = { name: "", send: "", recv: "" };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<ParameterFunction>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ParameterFunction): ParameterFunction {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* string Send = 2 [json_name = "Send"];*/ 2:
                    message.send = reader.string();
                    break;
                case /* string Recv = 3 [json_name = "Recv"];*/ 3:
                    message.recv = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: ParameterFunction, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* string Send = 2 [json_name = "Send"]; */
        if (message.send !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.send);
        /* string Recv = 3 [json_name = "Recv"]; */
        if (message.recv !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.recv);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.ParameterFunction
 */
export const ParameterFunction = new ParameterFunction$Type();
// @generated message type with reflection information, may provide speed optimized methods
class Vault$Type extends MessageType<Vault> {
    constructor() {
        super("listener.Vault", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Address", kind: "scalar", jsonName: "Address", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "Token", kind: "scalar", jsonName: "Token", T: 9 /*ScalarType.STRING*/ },
            { no: 4, name: "Keys", kind: "scalar", jsonName: "Keys", repeat: 2 /*RepeatType.UNPACKED*/, T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<Vault>): Vault {
        const message = { name: "", address: "", token: "", keys: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<Vault>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Vault): Vault {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* string Address = 2 [json_name = "Address"];*/ 2:
                    message.address = reader.string();
                    break;
                case /* string Token = 3 [json_name = "Token"];*/ 3:
                    message.token = reader.string();
                    break;
                case /* repeated string Keys = 4 [json_name = "Keys"];*/ 4:
                    message.keys.push(reader.string());
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: Vault, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* string Address = 2 [json_name = "Address"]; */
        if (message.address !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.address);
        /* string Token = 3 [json_name = "Token"]; */
        if (message.token !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.token);
        /* repeated string Keys = 4 [json_name = "Keys"]; */
        for (let i = 0; i < message.keys.length; i++)
            writer.tag(4, WireType.LengthDelimited).string(message.keys[i]);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.Vault
 */
export const Vault = new Vault$Type();
// @generated message type with reflection information, may provide speed optimized methods
class RouterListener$Type extends MessageType<RouterListener> {
    constructor() {
        super("listener.RouterListener", [
            { no: 1, name: "Name", kind: "scalar", jsonName: "Name", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Pem", kind: "scalar", jsonName: "Pem", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "Port", kind: "scalar", jsonName: "Port", T: 5 /*ScalarType.INT32*/ },
            { no: 4, name: "Listen", kind: "scalar", jsonName: "Listen", T: 9 /*ScalarType.STRING*/ },
            { no: 5, name: "Secure", kind: "scalar", jsonName: "Secure", T: 8 /*ScalarType.BOOL*/ },
            { no: 6, name: "AutoReloadPemDir", kind: "scalar", jsonName: "AutoReloadPemDir", T: 8 /*ScalarType.BOOL*/ },
            { no: 7, name: "Vault", kind: "message", jsonName: "Vault", T: () => Vault }
        ]);
    }
    create(value?: PartialMessage<RouterListener>): RouterListener {
        const message = { name: "", pem: "", port: 0, listen: "", secure: false, autoReloadPemDir: false };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<RouterListener>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RouterListener): RouterListener {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Name = 1 [json_name = "Name"];*/ 1:
                    message.name = reader.string();
                    break;
                case /* string Pem = 2 [json_name = "Pem"];*/ 2:
                    message.pem = reader.string();
                    break;
                case /* int32 Port = 3 [json_name = "Port"];*/ 3:
                    message.port = reader.int32();
                    break;
                case /* string Listen = 4 [json_name = "Listen"];*/ 4:
                    message.listen = reader.string();
                    break;
                case /* bool Secure = 5 [json_name = "Secure"];*/ 5:
                    message.secure = reader.bool();
                    break;
                case /* bool AutoReloadPemDir = 6 [json_name = "AutoReloadPemDir"];*/ 6:
                    message.autoReloadPemDir = reader.bool();
                    break;
                case /* listener.Vault Vault = 7 [json_name = "Vault"];*/ 7:
                    message.vault = Vault.internalBinaryRead(reader, reader.uint32(), options, message.vault);
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: RouterListener, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Name = 1 [json_name = "Name"]; */
        if (message.name !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.name);
        /* string Pem = 2 [json_name = "Pem"]; */
        if (message.pem !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.pem);
        /* int32 Port = 3 [json_name = "Port"]; */
        if (message.port !== 0)
            writer.tag(3, WireType.Varint).int32(message.port);
        /* string Listen = 4 [json_name = "Listen"]; */
        if (message.listen !== "")
            writer.tag(4, WireType.LengthDelimited).string(message.listen);
        /* bool Secure = 5 [json_name = "Secure"]; */
        if (message.secure !== false)
            writer.tag(5, WireType.Varint).bool(message.secure);
        /* bool AutoReloadPemDir = 6 [json_name = "AutoReloadPemDir"]; */
        if (message.autoReloadPemDir !== false)
            writer.tag(6, WireType.Varint).bool(message.autoReloadPemDir);
        /* listener.Vault Vault = 7 [json_name = "Vault"]; */
        if (message.vault)
            Vault.internalBinaryWrite(message.vault, writer.tag(7, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.RouterListener
 */
export const RouterListener = new RouterListener$Type();
// @generated message type with reflection information, may provide speed optimized methods
class ServicesItems$Type extends MessageType<ServicesItems> {
    constructor() {
        super("listener.ServicesItems", [
            { no: 1, name: "Service", kind: "scalar", jsonName: "Service", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Method", kind: "scalar", jsonName: "Method", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "FullMethod", kind: "scalar", jsonName: "FullMethod", T: 9 /*ScalarType.STRING*/ },
            { no: 4, name: "HttpTranslator", kind: "scalar", jsonName: "HttpTranslator", repeat: 2 /*RepeatType.UNPACKED*/, T: 9 /*ScalarType.STRING*/ },
            { no: 5, name: "Input", kind: "message", jsonName: "Input", repeat: 1 /*RepeatType.PACKED*/, T: () => ParameterFunction },
            { no: 6, name: "Output", kind: "message", jsonName: "Output", repeat: 1 /*RepeatType.PACKED*/, T: () => ParameterFunction },
            { no: 7, name: "ServerStream", kind: "scalar", jsonName: "ServerStream", T: 8 /*ScalarType.BOOL*/ },
            { no: 8, name: "ClientStream", kind: "scalar", jsonName: "ClientStream", T: 8 /*ScalarType.BOOL*/ },
            { no: 9, name: "ProtoReference", kind: "scalar", jsonName: "ProtoReference", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<ServicesItems>): ServicesItems {
        const message = { service: "", method: "", fullMethod: "", httpTranslator: [], input: [], output: [], serverStream: false, clientStream: false, protoReference: "" };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<ServicesItems>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ServicesItems): ServicesItems {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Service = 1 [json_name = "Service"];*/ 1:
                    message.service = reader.string();
                    break;
                case /* string Method = 2 [json_name = "Method"];*/ 2:
                    message.method = reader.string();
                    break;
                case /* string FullMethod = 3 [json_name = "FullMethod"];*/ 3:
                    message.fullMethod = reader.string();
                    break;
                case /* repeated string HttpTranslator = 4 [json_name = "HttpTranslator"];*/ 4:
                    message.httpTranslator.push(reader.string());
                    break;
                case /* repeated listener.ParameterFunction Input = 5 [json_name = "Input"];*/ 5:
                    message.input.push(ParameterFunction.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                case /* repeated listener.ParameterFunction Output = 6 [json_name = "Output"];*/ 6:
                    message.output.push(ParameterFunction.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                case /* bool ServerStream = 7 [json_name = "ServerStream"];*/ 7:
                    message.serverStream = reader.bool();
                    break;
                case /* bool ClientStream = 8 [json_name = "ClientStream"];*/ 8:
                    message.clientStream = reader.bool();
                    break;
                case /* string ProtoReference = 9 [json_name = "ProtoReference"];*/ 9:
                    message.protoReference = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: ServicesItems, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Service = 1 [json_name = "Service"]; */
        if (message.service !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.service);
        /* string Method = 2 [json_name = "Method"]; */
        if (message.method !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.method);
        /* string FullMethod = 3 [json_name = "FullMethod"]; */
        if (message.fullMethod !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.fullMethod);
        /* repeated string HttpTranslator = 4 [json_name = "HttpTranslator"]; */
        for (let i = 0; i < message.httpTranslator.length; i++)
            writer.tag(4, WireType.LengthDelimited).string(message.httpTranslator[i]);
        /* repeated listener.ParameterFunction Input = 5 [json_name = "Input"]; */
        for (let i = 0; i < message.input.length; i++)
            ParameterFunction.internalBinaryWrite(message.input[i], writer.tag(5, WireType.LengthDelimited).fork(), options).join();
        /* repeated listener.ParameterFunction Output = 6 [json_name = "Output"]; */
        for (let i = 0; i < message.output.length; i++)
            ParameterFunction.internalBinaryWrite(message.output[i], writer.tag(6, WireType.LengthDelimited).fork(), options).join();
        /* bool ServerStream = 7 [json_name = "ServerStream"]; */
        if (message.serverStream !== false)
            writer.tag(7, WireType.Varint).bool(message.serverStream);
        /* bool ClientStream = 8 [json_name = "ClientStream"]; */
        if (message.clientStream !== false)
            writer.tag(8, WireType.Varint).bool(message.clientStream);
        /* string ProtoReference = 9 [json_name = "ProtoReference"]; */
        if (message.protoReference !== "")
            writer.tag(9, WireType.LengthDelimited).string(message.protoReference);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.ServicesItems
 */
export const ServicesItems = new ServicesItems$Type();
// @generated message type with reflection information, may provide speed optimized methods
class MonitorRequest$Type extends MessageType<MonitorRequest> {
    constructor() {
        super("listener.MonitorRequest", [
            { no: 1, name: "DisableHostInfo", kind: "scalar", jsonName: "DisableHostInfo", T: 8 /*ScalarType.BOOL*/ }
        ]);
    }
    create(value?: PartialMessage<MonitorRequest>): MonitorRequest {
        const message = { disableHostInfo: false };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<MonitorRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitorRequest): MonitorRequest {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* bool DisableHostInfo = 1 [json_name = "DisableHostInfo"];*/ 1:
                    message.disableHostInfo = reader.bool();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: MonitorRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* bool DisableHostInfo = 1 [json_name = "DisableHostInfo"]; */
        if (message.disableHostInfo !== false)
            writer.tag(1, WireType.Varint).bool(message.disableHostInfo);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.MonitorRequest
 */
export const MonitorRequest = new MonitorRequest$Type();
// @generated message type with reflection information, may provide speed optimized methods
class RateLimit$Type extends MessageType<RateLimit> {
    constructor() {
        super("listener.RateLimit", [
            { no: 1, name: "ID", kind: "scalar", jsonName: "ID", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Alias", kind: "scalar", jsonName: "Alias", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "Type", kind: "scalar", jsonName: "Type", T: 9 /*ScalarType.STRING*/ },
            { no: 4, name: "Limit", kind: "scalar", jsonName: "Limit", T: 1 /*ScalarType.DOUBLE*/ },
            { no: 5, name: "Current", kind: "scalar", jsonName: "Current", T: 3 /*ScalarType.INT64*/, L: 0 /*LongType.BIGINT*/ }
        ]);
    }
    create(value?: PartialMessage<RateLimit>): RateLimit {
        const message = { iD: "", alias: "", type: "", limit: 0, current: 0n };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<RateLimit>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RateLimit): RateLimit {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string ID = 1 [json_name = "ID"];*/ 1:
                    message.iD = reader.string();
                    break;
                case /* string Alias = 2 [json_name = "Alias"];*/ 2:
                    message.alias = reader.string();
                    break;
                case /* string Type = 3 [json_name = "Type"];*/ 3:
                    message.type = reader.string();
                    break;
                case /* double Limit = 4 [json_name = "Limit"];*/ 4:
                    message.limit = reader.double();
                    break;
                case /* int64 Current = 5 [json_name = "Current"];*/ 5:
                    message.current = reader.int64().toBigInt();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: RateLimit, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string ID = 1 [json_name = "ID"]; */
        if (message.iD !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.iD);
        /* string Alias = 2 [json_name = "Alias"]; */
        if (message.alias !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.alias);
        /* string Type = 3 [json_name = "Type"]; */
        if (message.type !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.type);
        /* double Limit = 4 [json_name = "Limit"]; */
        if (message.limit !== 0)
            writer.tag(4, WireType.Bit64).double(message.limit);
        /* int64 Current = 5 [json_name = "Current"]; */
        if (message.current !== 0n)
            writer.tag(5, WireType.Varint).int64(message.current);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.RateLimit
 */
export const RateLimit = new RateLimit$Type();
// @generated message type with reflection information, may provide speed optimized methods
class MonitorResponse$Type extends MessageType<MonitorResponse> {
    constructor() {
        super("listener.MonitorResponse", [
            { no: 1, name: "ServicesName", kind: "scalar", jsonName: "ServicesName", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Time", kind: "scalar", jsonName: "Time", T: 3 /*ScalarType.INT64*/, L: 0 /*LongType.BIGINT*/ },
            { no: 3, name: "Host", kind: "message", jsonName: "Host", T: () => Host },
            { no: 4, name: "Services", kind: "message", jsonName: "Services", T: () => Services },
            { no: 5, name: "RateLimit", kind: "message", jsonName: "RateLimit", repeat: 1 /*RepeatType.PACKED*/, T: () => RateLimit }
        ]);
    }
    create(value?: PartialMessage<MonitorResponse>): MonitorResponse {
        const message = { servicesName: "", time: 0n, rateLimit: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<MonitorResponse>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitorResponse): MonitorResponse {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string ServicesName = 1 [json_name = "ServicesName"];*/ 1:
                    message.servicesName = reader.string();
                    break;
                case /* int64 Time = 2 [json_name = "Time"];*/ 2:
                    message.time = reader.int64().toBigInt();
                    break;
                case /* listener.Host Host = 3 [json_name = "Host"];*/ 3:
                    message.host = Host.internalBinaryRead(reader, reader.uint32(), options, message.host);
                    break;
                case /* listener.Services Services = 4 [json_name = "Services"];*/ 4:
                    message.services = Services.internalBinaryRead(reader, reader.uint32(), options, message.services);
                    break;
                case /* repeated listener.RateLimit RateLimit = 5 [json_name = "RateLimit"];*/ 5:
                    message.rateLimit.push(RateLimit.internalBinaryRead(reader, reader.uint32(), options));
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: MonitorResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string ServicesName = 1 [json_name = "ServicesName"]; */
        if (message.servicesName !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.servicesName);
        /* int64 Time = 2 [json_name = "Time"]; */
        if (message.time !== 0n)
            writer.tag(2, WireType.Varint).int64(message.time);
        /* listener.Host Host = 3 [json_name = "Host"]; */
        if (message.host)
            Host.internalBinaryWrite(message.host, writer.tag(3, WireType.LengthDelimited).fork(), options).join();
        /* listener.Services Services = 4 [json_name = "Services"]; */
        if (message.services)
            Services.internalBinaryWrite(message.services, writer.tag(4, WireType.LengthDelimited).fork(), options).join();
        /* repeated listener.RateLimit RateLimit = 5 [json_name = "RateLimit"]; */
        for (let i = 0; i < message.rateLimit.length; i++)
            RateLimit.internalBinaryWrite(message.rateLimit[i], writer.tag(5, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.MonitorResponse
 */
export const MonitorResponse = new MonitorResponse$Type();
// @generated message type with reflection information, may provide speed optimized methods
class Cpu$Type extends MessageType<Cpu> {
    constructor() {
        super("listener.Cpu", [
            { no: 1, name: "UsagePercent", kind: "scalar", jsonName: "UsagePercent", T: 2 /*ScalarType.FLOAT*/ }
        ]);
    }
    create(value?: PartialMessage<Cpu>): Cpu {
        const message = { usagePercent: 0 };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<Cpu>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Cpu): Cpu {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* float UsagePercent = 1 [json_name = "UsagePercent"];*/ 1:
                    message.usagePercent = reader.float();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: Cpu, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* float UsagePercent = 1 [json_name = "UsagePercent"]; */
        if (message.usagePercent !== 0)
            writer.tag(1, WireType.Bit32).float(message.usagePercent);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.Cpu
 */
export const Cpu = new Cpu$Type();
// @generated message type with reflection information, may provide speed optimized methods
class Memory$Type extends MessageType<Memory> {
    constructor() {
        super("listener.Memory", [
            { no: 1, name: "Total", kind: "scalar", jsonName: "Total", T: 4 /*ScalarType.UINT64*/, L: 0 /*LongType.BIGINT*/ },
            { no: 2, name: "TotalString", kind: "scalar", jsonName: "TotalString", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "Usage", kind: "scalar", jsonName: "Usage", T: 4 /*ScalarType.UINT64*/, L: 0 /*LongType.BIGINT*/ },
            { no: 4, name: "UsageString", kind: "scalar", jsonName: "UsageString", T: 9 /*ScalarType.STRING*/ },
            { no: 5, name: "UsagePercent", kind: "scalar", jsonName: "UsagePercent", T: 2 /*ScalarType.FLOAT*/ }
        ]);
    }
    create(value?: PartialMessage<Memory>): Memory {
        const message = { total: 0n, totalString: "", usage: 0n, usageString: "", usagePercent: 0 };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<Memory>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Memory): Memory {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* uint64 Total = 1 [json_name = "Total"];*/ 1:
                    message.total = reader.uint64().toBigInt();
                    break;
                case /* string TotalString = 2 [json_name = "TotalString"];*/ 2:
                    message.totalString = reader.string();
                    break;
                case /* uint64 Usage = 3 [json_name = "Usage"];*/ 3:
                    message.usage = reader.uint64().toBigInt();
                    break;
                case /* string UsageString = 4 [json_name = "UsageString"];*/ 4:
                    message.usageString = reader.string();
                    break;
                case /* float UsagePercent = 5 [json_name = "UsagePercent"];*/ 5:
                    message.usagePercent = reader.float();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: Memory, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* uint64 Total = 1 [json_name = "Total"]; */
        if (message.total !== 0n)
            writer.tag(1, WireType.Varint).uint64(message.total);
        /* string TotalString = 2 [json_name = "TotalString"]; */
        if (message.totalString !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.totalString);
        /* uint64 Usage = 3 [json_name = "Usage"]; */
        if (message.usage !== 0n)
            writer.tag(3, WireType.Varint).uint64(message.usage);
        /* string UsageString = 4 [json_name = "UsageString"]; */
        if (message.usageString !== "")
            writer.tag(4, WireType.LengthDelimited).string(message.usageString);
        /* float UsagePercent = 5 [json_name = "UsagePercent"]; */
        if (message.usagePercent !== 0)
            writer.tag(5, WireType.Bit32).float(message.usagePercent);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.Memory
 */
export const Memory = new Memory$Type();
// @generated message type with reflection information, may provide speed optimized methods
class Host$Type extends MessageType<Host> {
    constructor() {
        super("listener.Host", [
            { no: 1, name: "Cpu", kind: "message", jsonName: "Cpu", T: () => Cpu },
            { no: 2, name: "Memory", kind: "message", jsonName: "Memory", T: () => Memory },
            { no: 3, name: "HostInfo", kind: "message", jsonName: "HostInfo", T: () => HostInfo }
        ]);
    }
    create(value?: PartialMessage<Host>): Host {
        const message = {};
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<Host>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Host): Host {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* listener.Cpu Cpu = 1 [json_name = "Cpu"];*/ 1:
                    message.cpu = Cpu.internalBinaryRead(reader, reader.uint32(), options, message.cpu);
                    break;
                case /* listener.Memory Memory = 2 [json_name = "Memory"];*/ 2:
                    message.memory = Memory.internalBinaryRead(reader, reader.uint32(), options, message.memory);
                    break;
                case /* listener.HostInfo HostInfo = 3 [json_name = "HostInfo"];*/ 3:
                    message.hostInfo = HostInfo.internalBinaryRead(reader, reader.uint32(), options, message.hostInfo);
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: Host, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* listener.Cpu Cpu = 1 [json_name = "Cpu"]; */
        if (message.cpu)
            Cpu.internalBinaryWrite(message.cpu, writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        /* listener.Memory Memory = 2 [json_name = "Memory"]; */
        if (message.memory)
            Memory.internalBinaryWrite(message.memory, writer.tag(2, WireType.LengthDelimited).fork(), options).join();
        /* listener.HostInfo HostInfo = 3 [json_name = "HostInfo"]; */
        if (message.hostInfo)
            HostInfo.internalBinaryWrite(message.hostInfo, writer.tag(3, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.Host
 */
export const Host = new Host$Type();
// @generated message type with reflection information, may provide speed optimized methods
class HostInfo$Type extends MessageType<HostInfo> {
    constructor() {
        super("listener.HostInfo", [
            { no: 1, name: "Hostname", kind: "scalar", jsonName: "Hostname", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "Uptime", kind: "scalar", jsonName: "Uptime", T: 4 /*ScalarType.UINT64*/, L: 0 /*LongType.BIGINT*/ },
            { no: 3, name: "BootTime", kind: "scalar", jsonName: "BootTime", T: 4 /*ScalarType.UINT64*/, L: 0 /*LongType.BIGINT*/ },
            { no: 4, name: "Procs", kind: "scalar", jsonName: "Procs", T: 4 /*ScalarType.UINT64*/, L: 0 /*LongType.BIGINT*/ },
            { no: 5, name: "OS", kind: "scalar", jsonName: "OS", T: 9 /*ScalarType.STRING*/ },
            { no: 6, name: "Platform", kind: "scalar", jsonName: "Platform", T: 9 /*ScalarType.STRING*/ },
            { no: 7, name: "PlatformFamily", kind: "scalar", jsonName: "PlatformFamily", T: 9 /*ScalarType.STRING*/ },
            { no: 8, name: "PlatformVersion", kind: "scalar", jsonName: "PlatformVersion", T: 9 /*ScalarType.STRING*/ },
            { no: 9, name: "KernelVersion", kind: "scalar", jsonName: "KernelVersion", T: 9 /*ScalarType.STRING*/ },
            { no: 10, name: "KernelArch", kind: "scalar", jsonName: "KernelArch", T: 9 /*ScalarType.STRING*/ },
            { no: 11, name: "VirtualizationSystem", kind: "scalar", jsonName: "VirtualizationSystem", T: 9 /*ScalarType.STRING*/ },
            { no: 12, name: "VirtualizationRole", kind: "scalar", jsonName: "VirtualizationRole", T: 9 /*ScalarType.STRING*/ },
            { no: 13, name: "HostID", kind: "scalar", jsonName: "HostID", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<HostInfo>): HostInfo {
        const message = { hostname: "", uptime: 0n, bootTime: 0n, procs: 0n, oS: "", platform: "", platformFamily: "", platformVersion: "", kernelVersion: "", kernelArch: "", virtualizationSystem: "", virtualizationRole: "", hostID: "" };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<HostInfo>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: HostInfo): HostInfo {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Hostname = 1 [json_name = "Hostname"];*/ 1:
                    message.hostname = reader.string();
                    break;
                case /* uint64 Uptime = 2 [json_name = "Uptime"];*/ 2:
                    message.uptime = reader.uint64().toBigInt();
                    break;
                case /* uint64 BootTime = 3 [json_name = "BootTime"];*/ 3:
                    message.bootTime = reader.uint64().toBigInt();
                    break;
                case /* uint64 Procs = 4 [json_name = "Procs"];*/ 4:
                    message.procs = reader.uint64().toBigInt();
                    break;
                case /* string OS = 5 [json_name = "OS"];*/ 5:
                    message.oS = reader.string();
                    break;
                case /* string Platform = 6 [json_name = "Platform"];*/ 6:
                    message.platform = reader.string();
                    break;
                case /* string PlatformFamily = 7 [json_name = "PlatformFamily"];*/ 7:
                    message.platformFamily = reader.string();
                    break;
                case /* string PlatformVersion = 8 [json_name = "PlatformVersion"];*/ 8:
                    message.platformVersion = reader.string();
                    break;
                case /* string KernelVersion = 9 [json_name = "KernelVersion"];*/ 9:
                    message.kernelVersion = reader.string();
                    break;
                case /* string KernelArch = 10 [json_name = "KernelArch"];*/ 10:
                    message.kernelArch = reader.string();
                    break;
                case /* string VirtualizationSystem = 11 [json_name = "VirtualizationSystem"];*/ 11:
                    message.virtualizationSystem = reader.string();
                    break;
                case /* string VirtualizationRole = 12 [json_name = "VirtualizationRole"];*/ 12:
                    message.virtualizationRole = reader.string();
                    break;
                case /* string HostID = 13 [json_name = "HostID"];*/ 13:
                    message.hostID = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: HostInfo, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Hostname = 1 [json_name = "Hostname"]; */
        if (message.hostname !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.hostname);
        /* uint64 Uptime = 2 [json_name = "Uptime"]; */
        if (message.uptime !== 0n)
            writer.tag(2, WireType.Varint).uint64(message.uptime);
        /* uint64 BootTime = 3 [json_name = "BootTime"]; */
        if (message.bootTime !== 0n)
            writer.tag(3, WireType.Varint).uint64(message.bootTime);
        /* uint64 Procs = 4 [json_name = "Procs"]; */
        if (message.procs !== 0n)
            writer.tag(4, WireType.Varint).uint64(message.procs);
        /* string OS = 5 [json_name = "OS"]; */
        if (message.oS !== "")
            writer.tag(5, WireType.LengthDelimited).string(message.oS);
        /* string Platform = 6 [json_name = "Platform"]; */
        if (message.platform !== "")
            writer.tag(6, WireType.LengthDelimited).string(message.platform);
        /* string PlatformFamily = 7 [json_name = "PlatformFamily"]; */
        if (message.platformFamily !== "")
            writer.tag(7, WireType.LengthDelimited).string(message.platformFamily);
        /* string PlatformVersion = 8 [json_name = "PlatformVersion"]; */
        if (message.platformVersion !== "")
            writer.tag(8, WireType.LengthDelimited).string(message.platformVersion);
        /* string KernelVersion = 9 [json_name = "KernelVersion"]; */
        if (message.kernelVersion !== "")
            writer.tag(9, WireType.LengthDelimited).string(message.kernelVersion);
        /* string KernelArch = 10 [json_name = "KernelArch"]; */
        if (message.kernelArch !== "")
            writer.tag(10, WireType.LengthDelimited).string(message.kernelArch);
        /* string VirtualizationSystem = 11 [json_name = "VirtualizationSystem"]; */
        if (message.virtualizationSystem !== "")
            writer.tag(11, WireType.LengthDelimited).string(message.virtualizationSystem);
        /* string VirtualizationRole = 12 [json_name = "VirtualizationRole"]; */
        if (message.virtualizationRole !== "")
            writer.tag(12, WireType.LengthDelimited).string(message.virtualizationRole);
        /* string HostID = 13 [json_name = "HostID"]; */
        if (message.hostID !== "")
            writer.tag(13, WireType.LengthDelimited).string(message.hostID);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.HostInfo
 */
export const HostInfo = new HostInfo$Type();
// @generated message type with reflection information, may provide speed optimized methods
class ServicesInfo$Type extends MessageType<ServicesInfo> {
    constructor() {
        super("listener.ServicesInfo", [
            { no: 1, name: "Version", kind: "scalar", jsonName: "Version", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "GitCommit", kind: "scalar", jsonName: "GitCommit", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "GoVersion", kind: "scalar", jsonName: "GoVersion", T: 9 /*ScalarType.STRING*/ },
            { no: 4, name: "Compiler", kind: "scalar", jsonName: "Compiler", T: 9 /*ScalarType.STRING*/ },
            { no: 5, name: "BuildTime", kind: "scalar", jsonName: "BuildTime", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<ServicesInfo>): ServicesInfo {
        const message = { version: "", gitCommit: "", goVersion: "", compiler: "", buildTime: "" };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<ServicesInfo>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ServicesInfo): ServicesInfo {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Version = 1 [json_name = "Version"];*/ 1:
                    message.version = reader.string();
                    break;
                case /* string GitCommit = 2 [json_name = "GitCommit"];*/ 2:
                    message.gitCommit = reader.string();
                    break;
                case /* string GoVersion = 3 [json_name = "GoVersion"];*/ 3:
                    message.goVersion = reader.string();
                    break;
                case /* string Compiler = 4 [json_name = "Compiler"];*/ 4:
                    message.compiler = reader.string();
                    break;
                case /* string BuildTime = 5 [json_name = "BuildTime"];*/ 5:
                    message.buildTime = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: ServicesInfo, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Version = 1 [json_name = "Version"]; */
        if (message.version !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.version);
        /* string GitCommit = 2 [json_name = "GitCommit"]; */
        if (message.gitCommit !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.gitCommit);
        /* string GoVersion = 3 [json_name = "GoVersion"]; */
        if (message.goVersion !== "")
            writer.tag(3, WireType.LengthDelimited).string(message.goVersion);
        /* string Compiler = 4 [json_name = "Compiler"]; */
        if (message.compiler !== "")
            writer.tag(4, WireType.LengthDelimited).string(message.compiler);
        /* string BuildTime = 5 [json_name = "BuildTime"]; */
        if (message.buildTime !== "")
            writer.tag(5, WireType.LengthDelimited).string(message.buildTime);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.ServicesInfo
 */
export const ServicesInfo = new ServicesInfo$Type();
// @generated message type with reflection information, may provide speed optimized methods
class Services$Type extends MessageType<Services> {
    constructor() {
        super("listener.Services", [
            { no: 1, name: "Runtime", kind: "scalar", jsonName: "Runtime", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "NumGoroutine", kind: "scalar", jsonName: "NumGoroutine", T: 5 /*ScalarType.INT32*/ },
            { no: 3, name: "Pid", kind: "scalar", jsonName: "Pid", T: 5 /*ScalarType.INT32*/ },
            { no: 4, name: "Cpu", kind: "message", jsonName: "Cpu", T: () => Cpu },
            { no: 5, name: "Memory", kind: "message", jsonName: "Memory", T: () => Memory },
            { no: 6, name: "ServicesInfo", kind: "message", jsonName: "ServicesInfo", T: () => ServicesInfo }
        ]);
    }
    create(value?: PartialMessage<Services>): Services {
        const message = { runtime: "", numGoroutine: 0, pid: 0 };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<Services>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Services): Services {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string Runtime = 1 [json_name = "Runtime"];*/ 1:
                    message.runtime = reader.string();
                    break;
                case /* int32 NumGoroutine = 2 [json_name = "NumGoroutine"];*/ 2:
                    message.numGoroutine = reader.int32();
                    break;
                case /* int32 Pid = 3 [json_name = "Pid"];*/ 3:
                    message.pid = reader.int32();
                    break;
                case /* listener.Cpu Cpu = 4 [json_name = "Cpu"];*/ 4:
                    message.cpu = Cpu.internalBinaryRead(reader, reader.uint32(), options, message.cpu);
                    break;
                case /* listener.Memory Memory = 5 [json_name = "Memory"];*/ 5:
                    message.memory = Memory.internalBinaryRead(reader, reader.uint32(), options, message.memory);
                    break;
                case /* listener.ServicesInfo ServicesInfo = 6 [json_name = "ServicesInfo"];*/ 6:
                    message.servicesInfo = ServicesInfo.internalBinaryRead(reader, reader.uint32(), options, message.servicesInfo);
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: Services, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string Runtime = 1 [json_name = "Runtime"]; */
        if (message.runtime !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.runtime);
        /* int32 NumGoroutine = 2 [json_name = "NumGoroutine"]; */
        if (message.numGoroutine !== 0)
            writer.tag(2, WireType.Varint).int32(message.numGoroutine);
        /* int32 Pid = 3 [json_name = "Pid"]; */
        if (message.pid !== 0)
            writer.tag(3, WireType.Varint).int32(message.pid);
        /* listener.Cpu Cpu = 4 [json_name = "Cpu"]; */
        if (message.cpu)
            Cpu.internalBinaryWrite(message.cpu, writer.tag(4, WireType.LengthDelimited).fork(), options).join();
        /* listener.Memory Memory = 5 [json_name = "Memory"]; */
        if (message.memory)
            Memory.internalBinaryWrite(message.memory, writer.tag(5, WireType.LengthDelimited).fork(), options).join();
        /* listener.ServicesInfo ServicesInfo = 6 [json_name = "ServicesInfo"]; */
        if (message.servicesInfo)
            ServicesInfo.internalBinaryWrite(message.servicesInfo, writer.tag(6, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message listener.Services
 */
export const Services = new Services$Type();
/**
 * @generated ServiceType for protobuf service listener.Listener
 */
export const Listener = new ServiceType("listener.Listener", [
    { name: "Monitor", serverStreaming: true, options: {}, I: MonitorRequest, O: MonitorResponse },
    { name: "ListServices", options: {}, I: Empty, O: ServicesResponse },
    { name: "CurrentStatus", options: {}, I: MonitorRequest, O: MonitorResponse }
]);
